<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Watching Events</title>

    <link rel="stylesheet" href="/en/latest/css/core.css">
    <link rel="stylesheet" href="/en/latest/css/getstarted.css">
    <link rel="shortcut icon" href="/en/latest/css/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latest/css/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest/">Overview</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latest/contents.html">Documentation</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latest/topics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>Event-Driven Infrastructure</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="5">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/event/index.html">Event-Driven Infrastructure</a>
                </li>
                
                
                
                <li class="progtrckr-done">Watching Events</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/event/custom.html">Custom Events</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/event/beacons.html">Beacons</a>
                </li>
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/event/reactor.html">Event Reactor</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Watching Events</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Understand the event system basics</li>
                    
                    <li class="progtrckr-done">Monitor events</li>
                    
                    <li class="progtrckr-done">Understand event format and data</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>Salt’s internal components communicate with each other by sending and listening to events. In Salt, events are sent for about everything you could imagine:</p>
<ul>
<li>Salt minion connects</li>
<li>Key is accepted or rejected</li>
<li>Job is sent</li>
<li>Job results are returned from a minion</li>
<li>Presence heartbeats (turned off by default)</li>
</ul>
<p>Even the Salt command-line interface uses the event system. After a command is sent to the Salt master, the Salt CLI simply watches the event bus for job returns from targeted minions.</p>
<h2 id="watching-events">Watching Events</h2>
<div class="section sidebar">
<h4 id="salt-runners">Salt Runners</h4>
<p>Runners are modules that execute on the Salt master to perform supporting tasks. Runners report job status, show connection status, display events, read data from external APIs, query connected Salt minions, and more.</p>
</div>
<p>Salt provides a runner that displays events in real-time as they are received on the Salt master.</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-run</span> state.event pretty=True</code></pre>
<p>If you are using a <a href="../fundamentals/">demo environment</a> your event bus is probably quiet, so open another terminal and send a <code>salt '*' test.ping</code> command, or restart the <code>salt-minion</code> service on one of your minions.</p>
<p>The following are a few events that are similar to what you might see on your Salt master:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt/job/20150923203228234305/new</span>   {
    <span class="st">&quot;_stamp&quot;</span>: <span class="st">&quot;2015-09-23T20:32:28.235712&quot;</span>,
    <span class="st">&quot;arg&quot;</span>: [],
    <span class="st">&quot;fun&quot;</span>: <span class="st">&quot;test.ping&quot;</span>,
    <span class="st">&quot;jid&quot;</span>: <span class="st">&quot;20150923203228234305&quot;</span>,
    <span class="st">&quot;minions&quot;</span>:<span class="kw"> [</span>
        <span class="st">&quot;minion2&quot;</span>
    ],
    <span class="st">&quot;tgt&quot;</span>: <span class="st">&quot;*&quot;</span>,
    <span class="st">&quot;tgt_type&quot;</span>: <span class="st">&quot;glob&quot;</span>,
    <span class="st">&quot;user&quot;</span>: <span class="st">&quot;sudo_vagrant&quot;</span>
}</code></pre>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt/job/20150923203228234305/ret/minion2</span>   {
    <span class="st">&quot;_stamp&quot;</span>: <span class="st">&quot;2015-09-23T20:32:28.291789&quot;</span>,
    <span class="st">&quot;cmd&quot;</span>: <span class="st">&quot;_return&quot;</span>,
    <span class="st">&quot;fun&quot;</span>: <span class="st">&quot;test.ping&quot;</span>,
    <span class="st">&quot;fun_args&quot;</span>: [],
    <span class="st">&quot;id&quot;</span>: <span class="st">&quot;minion2&quot;</span>,
    <span class="st">&quot;jid&quot;</span>: <span class="st">&quot;20150923203228234305&quot;</span>,
    <span class="st">&quot;retcode&quot;</span>: <span class="kw">0</span>,
    <span class="st">&quot;return&quot;</span>: <span class="kw">true</span>,
    <span class="st">&quot;success&quot;</span>: <span class="kw">true</span>
}</code></pre>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt/auth</span>   {
    <span class="st">&quot;_stamp&quot;</span>: <span class="st">&quot;2015-09-23T20:30:02.998305&quot;</span>,
    <span class="st">&quot;act&quot;</span>: <span class="st">&quot;pend&quot;</span>,
    <span class="st">&quot;id&quot;</span>: <span class="st">&quot;minion1&quot;</span>,
    <span class="st">&quot;pub&quot;</span>: <span class="st">&quot;-----BEGIN PUBLIC KEY-----\...\n-----END PUBLIC KEY-----\n&quot;</span>,
    <span class="st">&quot;result&quot;</span>: <span class="kw">true</span>
}</code></pre>
<h2 id="event-format">Event Format</h2>
<p>Events are made up of two main parts: the tag which identifies the event that was fired, and the data that contains details about the event.</p>
<h3 id="event-tag">Event Tag</h3>
<p>All salt events are prefixed with <code>salt/</code>, with additional levels based on the type of event. For example, job events are prefixed with <code>salt/job/</code>. Each event part is separated using <code>/</code> to provide simple namespacing. This is identifier is called the event tag, and often contains specific details such as a job ID or minion ID.</p>
<p>Along with the event tag, each event also includes specific event data.</p>
<h3 id="event-data">Event Data</h3>
<p>Each event contains a <code>timestamp</code> and additional keys and values that are unique to that specific event.</p>
<p>Later when we explore the reactor, you’ll learn how to use the event tag and data to customize the reaction.</p>


            <br>
            
            <a href="/en/getstarted/event/index.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/event/custom.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
  <p>© 2020 SaltStack. All Rights Reserved, SaltStack Inc. | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latest/js/core-min.js"></script>



<!--analytics-->
<script type="text/javascript">llactid=23943</script>
<script type="text/javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>